fuzzydl

## Class DefuzzifyQuery

- java.lang.Object
- - fuzzydl.Query
  - - fuzzydl.DefuzzifyQuery

- Direct Known Subclasses:
    LomDefuzzifyQuery, MomDefuzzifyQuery, SomDefuzzifyQuery

      public abstract class DefuzzifyQuery
      extends Query

  Defuzzification query.
  Author:
    Fernando Bobillo

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefuzzifyQuery(Concept c, Individual ind, java.lang.String featureName)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract Expression` | `getObjExpression(Variable q)` Gets the objective expression.
    `void` | `preprocess(KnowledgeBase kb)` Performs some preprocessing steps of the query over a fuzzy KB.
    `Solution` | `solve(KnowledgeBase kb)` Solves the query over a fuzzy KB.

    - ### Methods inherited from class fuzzydl.Query

      `getTotalTime, setInitialTime, setTotalTime, toString`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefuzzifyQuery

          public DefuzzifyQuery(Concept c,
                                Individual ind,
                                java.lang.String featureName)

  - ### Method Detail

    - #### preprocess

          public void preprocess(KnowledgeBase kb)
                          throws FuzzyOntologyException,
                                 InconsistentOntologyException

      Description copied from class: `Query`
      Performs some preprocessing steps of the query over a fuzzy KB.
      Specified by:
        `preprocess` in class `Query`
      Parameters:
        `kb` - A fuzzy KB.
      Throws:
        `FuzzyOntologyException` - fuzzy ontology exception.
        `InconsistentOntologyException` - Inconsistent ontology.

    - #### solve

          public Solution solve(KnowledgeBase kb)
                         throws FuzzyOntologyException

      Description copied from class: `Query`
      Solves the query over a fuzzy KB.
      Specified by:
        `solve` in class `Query`
      Parameters:
        `kb` - A fuzzy KB.
      Returns:
        An optimal solution to the query.
      Throws:
        `FuzzyOntologyException` - fuzzy ontology exception.

    - #### getObjExpression

          public abstract Expression getObjExpression(Variable q)

      Gets the objective expression.
      Parameters:
        `q` - Variable taking part in the query.
      Returns:
        Objective expression.